/*
 * chainer_co.c
 *
 * Copyright (c) 1999,2000,2001 Hajime Mochizuki <motizuki@jaist.ac.jp>
 *   Natural Language Processing Laboratory,
 *   Japan Advanced Institute of Science and Technology.
 *
 *
 * Use of this software is granted only for RESEARCH PURPOSES. 
 * Redistribution is granted as long as all copyright notices are retained.
 * Redistribution with modification is allowed provided that you make your 
 * modified version obviously distinguishable from the original one.  
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR 
 * IMPLIED WARRANTIES ARE DISCLAIMED.
 *
 *  ɸϤǲϤη̤äϢĤ
 *  GETAѤ뤳ȤǶ׻򤽤ٷ׻С
 *
 *   -W ˤꡤֹ椬ͭñʳʬ⥫Ȥ롥
 *      ǲϷ̤1ǤȤ̵ͭˤ餺Ȥ롥
 *     (Υץ󤬤ĤʤϡͭñΤߤǥȤ)
 *
 */
#include <config.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <geta/config.h>
#include <geta/wam.h>
#include "coscr.h"

/*#include "cmn.h"*/
#include "mrpfil.h"
#include "cochainer.h"
/*#include "cooption.h"*/

char *mrf;
extern int mrp_type;           /* cocengine.c */
extern int chaflt_out_num;     /* mrpfil.c */
extern int number_of_words;    /* mrpfil.c */
extern double threshold;       /* coscr.c */

extern CHAFLT_OUT* indirect_chaflt (); /* mrpfil.c */
extern double get_max_score ();
extern struct tcblist *top_chain;
extern struct tcblist *btm_chain;

static help()
{
	fprintf (stderr, "Lexical Chainers version 1.50 -co-");
	fprintf (stderr, "   (c) 1999,2000,2001 motizuki@jaist.ac.jp\n");
	fprintf (stderr, "Usage: %s  handle [options] < morphfile\n", pname);
	fprintf (stderr, "INPUT TYPE Default=-cha\n");
	fprintf (stderr, "  -knp     : KNP -tab Ϥ\n");
	fprintf (stderr, "  -cha     : ChaSen 2.2.x  -e Ϥ\n");
	fprintf (stderr, "  -jum     : Juman3.61     -e Ϥ\n");
	fprintf (stderr, "FILTER FILE\n");
	fprintf (stderr, "  -rule <filename> : ñꥹȤʤɤ򵭽Ҥfileλ\n");
	fprintf (stderr, "CHAIN CALCULATION\n");
        fprintf (stderr, "  -F <num> :filter mode Ϣʻλ Default=0\n");
        fprintf (stderr, "\t\t 0 . ̾ ư ƻ\n");
        fprintf (stderr, "\t\t 1 . ̾ ---- ƻ\n");
        fprintf (stderr, "\t\t 2 . ̾ ---- ------\n");
        fprintf (stderr, "\t\t 3 . ̾ ư ------\n");
        fprintf (stderr, "\t\t 4 . ---- ư ------\n");
        fprintf (stderr, "\t\t 5 . ---- ư ƻ\n");
        fprintf (stderr, "\t\t 6 . ---- ---- ƻ\n");
	fprintf (stderr, "  -N <num>         : DF(Default=ư׻\n");
	fprintf (stderr, "  -calc_mode <num> :Default=1\n");
	fprintf (stderr, "\t\t 1 . TF.IDF df(x,y) * log( N/( df(x) * df(y) ))\n");
	fprintf (stderr, "\t\t 2 . M.I.   df(x,y) * N/( df(x) * df(y) )\n");
	fprintf (stderr, "\t\t10 . cosine sum( xi * yi ) / sqrt(xI^2) * sqrt(yi^2)\n");
	fprintf (stderr, "  -threshold <num> : 饹ޡ\n");
	fprintf (stderr, "OUTPUT TYPE\n");
	fprintf (stderr, "  -compth  : chainer_thcompatibleʽϤˤ\n");
	fprintf (stderr, "  -W       : Ϣñʳ⥫Ȥ\n");
	fprintf (stderr, "  -h       : help\n");
	fprintf (stderr, "  -de      : debug mode\n");
	exit(1);
}

void optchk (argc, argv)
    int   argc;
    char *argv[];
{
	pname = argv[0];

	/* N = 101058;           /* default for mainichi_1994 */
	/*hdl="mainichi_1994";*/
	filtermode = 0;

	calc_mode = 1;
	threshold = (double)0;
	max_score = (double)0;
	debug     = 0;
	ciw_sw    = 0; /* ͭñʳֹ˥Ȥ뤫ɤ 0ʤ*/
	mrp_type = 0;
	mrf =NULL;
	compth = 0; /* 1ʤ顤 chainer_thƱϤˤ */
	argc--, argv++;
	hdl=argv[0];
	N=0;
	argc--, argv++;

	while (argc>0 && *argv[0]=='-') {
		if (!strcmp(argv[0], "-calc_mode")) {
			argc--, argv++;
			calc_mode = atoi(argv[0]);
		} else if (!strcmp(argv[0], "-threshold")) {
			argc--, argv++;
			threshold = atof(argv[0]);
		} else if (!strcmp(argv[0], "-N")) {
			argc--, argv++;
			N = atoi(argv[0]);
		} else if (!strcmp(argv[0], "-de")) {
			debug = 1;
		} else if (!strcmp(argv[0], "-F")) {
			argc--, argv++;
			filtermode=atoi(argv[0]);
		} else if (!strcmp(argv[0], "-knp")) {
			mrp_type = 1;
		} else if (!strcmp(argv[0], "-cha")) {
			mrp_type = 0;
		} else if (!strcmp(argv[0], "-jum")) {
			mrp_type = 2;
		} else if (!strcmp(argv[0], "-rule")) {
			argc--, argv++;
			mrf = argv[0];
		} else if (!strcmp(argv[0], "-compth")) {
			compth=1;
		} else if (!strcmp(argv[0], "-h")) {
			help();
		} else if (!strcmp(argv[0], "-W")) {
			ciw_sw=1;
		} else {
			fprintf (stderr, "Invalid arg: %s\n", argv[0]);
			help();
		}
		argc--, argv++;
	}
	if (hdl==NULL) help();
}

/*
 * chasenƤФʤjumanƤФʤ
 * ǲϤη̤ϤȤС顥
 *
 *  -knp .. mrp_type = 1 ξknp -tabνϤϤȤ
 *  -cha .. mrp_type = 0 ξChaSen2.2.x  -eνϤϤȤ
 *  -jum .. mrp_type = 2 ξJUMAN3.61    -eνϤϤȤ
 */
int main (argc, argv)
     int   argc;
     char *argv[];
{
	int  sn, wn, pwn, realwn, allmrp;
	char buf[BUFSIZ], *cptr;
	struct clusterbase  *basep;
	CHAFLT_OUT  *words;
	WAM *w;
	extern WAM*  s_wam_init_h();
	extern struct clusterbase* sentence_level_chaining();

	basep = NULL;	/* base pointer (sentence level)*/

	optchk(argc, argv);

	w = s_wam_init_h (hdl);   /* wam/xr ν */
	if (w==NULL) help();
	N = wam_size(w, WAM_ROW);
	max_score = get_max_score (calc_mode, N);

	top_chain = NULL;
	btm_chain = NULL;

	sn=wn=realwn=1; /* ʸֹ桤ֹ1Ϥޤ */
	chaflt_out_num=0;/* indirect_chafltȤˤɬ */
	allmrp=0; /* allrmp ǿ롥ѹ*/

	while (fgets(buf, BUFSIZ, stdin)!=NULL) {
		buf[strlen(buf)-1]='\0'; 		/* \n  */
		/* EOSjuman,chasenòƤޤŶ */
		if (strcmp(buf, "EOS")==0) { /*ʸѤä*/
			if (chaflt_out_num>0) {
				/*ñxrϥåϿ*/
				xrhash_update (words, w);
				basep = sentence_level_chaining (words);
				text_level_chaining(basep);
				chaflt_out_num=0; /*indirect_chafltȤˤɬ*/
			}
			sn++;/* ʸֹ 1䤹*/
			wn=1;/* ֹ Ͻ */
			realwn=1;
		} else if (mrp_type==1 && /* KNP -tab */
			    ((buf[0] == '#' && buf[1] == ' ' &&
			      buf[2] == 'S') ||
			     (buf[0] == '*' && buf[1] == ' ')||
			     (buf[0] == ';' && buf[1] == ';'))) {
			;
		} else {
			pwn=wn;
			/*ͭñ*/
			words=indirect_chaflt(buf,sn,&wn,filtermode,realwn,mrp_type,mrf);
			realwn++;
			/*
			  if (ciw_sw==1 && pwn==wn) wn++;
			*/
			allmrp++;
		}
	}
	s_wam_finish (w);
	/* printf ("%d %d\n", number_of_words-1, sn-1); /* ɬ */
	printf ("%d %d %d\n", number_of_words-1, sn-1, allmrp); /* ɬ <-ѹ */

#ifdef TEST3
	print_chains(1,ciw_sw);
#else
	print_chains(2,ciw_sw,compth);
#endif
	exit(0);
}


