/*
 * cengine.c
 *
 * Copyright (c) 2000, 2001 Hajime Mochizuki <motizuki@jaist.ac.jp>
 *   Natural Language Processing Laboratory,
 *   Japan Advanced Institute of Science and Technology.
 *
 *
 * Use of this software is granted only for RESEARCH PURPOSES. 
 * Redistribution is granted as long as all copyright notices are retained.
 * Redistribution with modification is allowed provided that you make your 
 * modified version obviously distinguishable from the original one.  
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR 
 * IMPLIED WARRANTIES ARE DISCLAIMED.
 *
 *
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* for CHAR_BIT */
#if defined(BSD44) || defined(DIGITAL)
#include <machine/limits.h>
#else
#include <limits.h>
#endif

/*#include <malloc.h>*/
#include "chainer.h"
/*#include "option.h"*/
/* #include "cha2dat.h"*/
#include "mrp2dat.h"
#include "nero.h"

int       wordlistno = 0;
int wnum_total;
/*int debug;*/

/*CONCEPTS      cwmatrix[IDN+1];   /* concept-word matrix */
CONCEPTS      cwmatrix[300+1];   /* concept-word matrix */
/*char *pfn;*/
int filtermode;

int ciw_sw;
int use_knp;
int mrp_type;

/*extern struct patrash_answer_ptr* tell_patrash_ptr();*/


void init_cwmatrix (size)
	int size;
{
	int i, j;

	for (i=0; i<size; i++) {
		cwmatrix[i].id[0]='\0';
		for (j=0; j<WN; j++) {
			cwmatrix[i].entity[j]=0;
			cwmatrix[i].info[j]=NULL;
		}
		cwmatrix[i].sum=0;
	}
}

int Hash (s, sw)
    char* s;
    int   sw;
{
	unsigned    v;
	for(v = 0; *s != '\0'; s++){
		if (sw == 1)
		     v = (( v << CHAR_BIT) + *s) % HASHSIZE;
		else if( sw == 2 )
		     v = (( v << CHAR_BIT) + *s) % HASHSIZE2;
	}
	return((int)v);
}

/*
 * quick sort
 */
void quick (left, right, a)
    int left;
    int right;
    CONCEPTS a[];
{
    int i, j, x;
    CONCEPTS l;

    if( left<right ){
	x = a[((left+right)/2)].sum;
	i = left-1; j = right+1;
	while (1) {
	    while (a[++i].sum > x);
	    while (a[--j].sum < x);
	    if( i>=j )	break;
/*	    a[l] = a[i];	/* a[l] = a[i] ̣ */
	    l = a[i];
	    a[i] = a[j];
/*	    a[j] = a[l];*/
	    a[j] = l;
	}
	quick(left, i-1, a);
	quick(j+1,  right, a);
    }
}

/*
 * Ϥ줿 idֹˤäơcwmatrix[soeji]soeji֤ 
 * 
 */
int Hash_UPDATE (idname, now, wn)
     char* idname;
     int   now;
     int   wn;
{
	int n;
	POSITION *p;

	n = Hash(idname,1);
	if (n > SPENDHASH)  SPENDHASH = n;

	if (*(position+n)!=NULL) { /* hashΤ֤꤬ʤ */
		for (p=*(position+n); p!=NULL; p=p->next_point) {
			if (strcmp(idname, p->id)==0) { /* Ǥ¸ߤƤ */
				if (p->lwn < wn) {
					now = p->pos;
					p->lwn = wn;
				} else { /* Ʊ֤Ʊid2ʾи*/
					now = p->pos;
					now = (-1)*now; /* οˤƼ */
				}
				return now;
			}
		}
	}
       /* ꥹȤɲäʤȤʤ */
	if ((p=calloc((size_t)1, sizeof(POSITION)))==NULL) {
		fprintf(stderr, "Memory over!!\n");
		exit(1);
	}
	strcpy(p->id, idname);
	p->pos = now;
	p->lwn = wn;
	p->next_point = *(position+n);
	*(position+n) = p;
	return now;
}

void init_hash()
{
	int i;

	for (i=0; i<HASHSIZE; i++) {
		*(position+i) = NULL;
	}
}

/*
 * hash ν
 */
void clear_hash()
{
	int i;
	POSITION  *old, *new;

	/* Ȥäʬ(ΤˤϻȤäȤޤ) */
	for (i=0; i<= SPENDHASH; i++) {
		old = *(position+i);
		while (old != NULL) {
/*			printf ("%p ID=%s\n", old, old->id);*/
			new = old->next_point;
			old->id[0]='\0';
			free(old); old = NULL;
/*			free(old);*/
			old = new;
		}
		*(position+i) = NULL;
	}
}

/*
 * 1ñν򤹤Ȥ
 */
int word_level (term, sn, wn, cats, idnum, jos, realwn, josw)
     unsigned char* term;
     int sn, wn, idnum, realwn;
     unsigned char* cats;
     unsigned char* jos;
     unsigned char* josw;
{
	unsigned char cat0[(IDLEVELMAX*SENSEMAXLEN)+TERMMAXLEN];
	unsigned char cat1[(IDLEVELMAX*SENSEMAXLEN)];
	unsigned char data[((SENSEMAXLEN*IDLEVELMAX)+ELEMMAXLEN)]; /* 700 */
	unsigned char data2[IDLEVELMAX][SENSEMAXLEN];/* 5, 200 */
	unsigned char wordinfo[(SENSEMAXNUM*INFOMAXLEN)/2];/*20*500/2=10000/2*/
	unsigned char ID[32]; /*, *wordinfo, *data;/*, **data2;*/
	int i, j, soeji, wordpos;
	char yomi[TERMMAXLEN];
	WORDINFO *wi;

	strcpy(word[wn-1],  term);
	strcpy(joshi[wn-1], jos);
	strcpy(joswd[wn-1], josw);

	/* ids[0]........                     ids[1]........
	/* ID01\sID02\sID03\sID04\sID05\tYOMI;ID11\sID12\s.... */
	for(i=0; cats[0]!='\0'; i++) {
		cat0[0]='\0';
		splitdata(cat0, cats, ';');
		splitdata(cat1, cat0, ':');
		strcpy(yomi, cat0);

		for (j=0; j<IDLEVELMAX; j++) {
			data2[j][0]='\0';
			splitdata(data2[j], cat1, ',');
		}
		/* -j ץбǤ*/
		switch (USEIDLEVEL) {
		   case 0: /* ⤷ʤ */
			break;
		   case 1: /* data2[1],[2] = '0' ˤ */
			strcpy(data2[1], "0");
			strcpy(data2[2], "0");
			break;
		   case 2: /* data2[0]=data[1] ˤơ0ˤ */
			strcpy(data2[0], data2[1]);
			strcpy(data2[1], "0");
			strcpy(data2[2], "0");
			break;
		   case 3: /* data2[0]=data[2] ˤơ0ˤ */
			strcpy(data2[0], data2[2]);
			strcpy(data2[1], "0");
			strcpy(data2[2], "0");
			break;
		   case 4:
			strcpy(data2[0], data2[3]);
			strcpy(data2[1], "0");
			strcpy(data2[2], "0");
			break;
		   case 5:
			strcpy(data2[0], data2[4]);
			strcpy(data2[1], "0");
			strcpy(data2[2], "0");
			break;
		}
		data[0]='\0';
		sprintf(data,"%s,%s,%s,%s", data2[0],data2[1],data2[2],	yomi);

		/* -i бǤIDLEVEL ϡθIDγ(0IDʤ) */
		switch (IDLEVEL) {
		   case 0: /* ƻ */
			strcpy(ID, term);
			break;
		   case 1:
			if (strcmp(data2[0],"0")==0) strcpy(ID, term);
			else  			     strcpy(ID, data2[0]);
			break;
		   case 2:
			if (strcmp(data2[0],"0")==0) strcpy(ID, term);
			else 	sprintf (ID, "%s,%s", data2[0], data2[1]);
			break;
		   case 3:
			if (strcmp(data2[0],"0")==0) strcpy(ID, term);
			else sprintf(ID, "%s,%s,%s", data2[0], data2[1], data2[2]);
			break;
		   case 4:
			if (strcmp(data2[0],"0")==0) strcpy(ID, term);
			else sprintf(ID, "%s,%s,%s,%s",
				     data2[0], data2[1], data2[2], data2[3]);
			break;
		   case 5:
			if (strcmp(data2[0],"0")==0) strcpy(ID, term);
			else sprintf(ID, "%s,%s,%s,%s,%s",
				     data2[0],data2[1],data2[2],data2[3],data2[4]);
			break;
		}

		soeji = Hash_UPDATE(ID, idnum, wn);
		if (soeji >-1) {
			strcpy(cwmatrix[soeji].id, ID);
			cwmatrix[soeji].entity[wn-1] = 1;
			cwmatrix[soeji].sum++;

			/* infoñΥ饹Υȥݻ */
			if ((wi=calloc((size_t)1, sizeof(WORDINFO)))==NULL) {
				fprintf (stderr, "Memory over!!\n");
				exit(1);
			} 

			if (WordInfoStart==NULL) WordInfoStart=wi;
			else                     WordInfoNow->next=wi;
			WordInfoNow = wi;
			wi->next    = NULL;
			
			cwmatrix[soeji].info[wn-1] = wi;
			wordinfo[0]='\0';

			/* chainץȴƱϤˤ뤿 */

			sprintf (wi->info, "(%s,%s,%s,[(%s)",
				 data2[0],data2[1],data2[2], data);
			/****** over run뤫⤷ʤ ***/
			/* wi->info ϡSENSEMAXNUM*INFOMAXLEN = 20*500=10000 */

			strcpy(wi->concept, ID);
			wi->realsn = sn;  	/* ɲ 99/07/02 */
			wi->realwn = realwn;	/* ɲ 99/07/02 */
			if (soeji == idnum) idnum++;

		} else {           /* Ʊñ֤ID֤äƤ */
			soeji = (-1)*soeji;  /* ο᤹ */
			wi = cwmatrix[soeji].info[wn-1];
			wordinfo[0]='\0';

			sprintf(wi->info, "%s,(%s)", wi->info, data);
			/******* over run뤫⤷ʤ ***/
			/* wi->info ϡSENSEMAXNUM*INFOMAXLEN = 20*500 =10000 */
		}
	}
	/*free(wordinfo);wordinfo=NULL;*/
	/*free(data); data=NULL;*/
	/*
	for (i=0; i<IDLEVELMAX; i++) {
		free(data2[i]); data2[i]=NULL;
	}
	free(data2); data2=NULL;
	*/
	return idnum;
}

/* -- ̤ --*/
void test1 (wn, bottom)
     int  wn;
     int  bottom;
{
    int i, j;

    for (i=0; i<bottom; i++) {
	printf( "ID=%s ", cwmatrix[i].id);
	for (j=0; j<wn; j++) printf( "%d ", cwmatrix[i].entity[j]);
	printf( "SUM=%d\n", cwmatrix[i].sum);
    }
    printf( "\n" );
}

void testest()
{
	;
}

/*
 * sentence_level_disamb .. 1ʸǤۣ
 * word_level  ¤cwmatrix ID-Word01ɽƤ
 * ޤиID¿Ϣν˥Ȥ
 * ֤ϢοʬˤʤϢõפȤˤäƽ
 */
void sentence_level_disamb(wn, idnum)
     int  wn;
     int  idnum;
{
    int i, j, k, l, hantei;
    
    quick(0, idnum-1, cwmatrix);        /* Ϣ(.sum)¿sort */
    for (i=0; i<wn; i++) {            /* Ƭ1 termĸƤ */
	for (j=0; j<idnum; j++) {     /* 1ʸ˽иID˸Ƥ */
	    if (cwmatrix[j].entity[i] == 1) {
		/* Τ(term iϡID jäƤ) */
		for (k=j+1; k<idnum; k++) { /* termλ¾IDõ */
		    hantei = 0;
		    if (cwmatrix[k].entity[i] == 1) { /* ¾ID k˥ޥå */
			/* ID k¾term lõ */
			for (l=0; l<wn; l++) { 
			    if (cwmatrix[k].entity[l] == 1) { /* ޥå */
				/* term l term iƱ IDĤå*/
				if (cwmatrix[j].entity[l] == 0) {
				    /* ƱIDʤȿʬˤ */
				    /* ФˤʤʤΤǡåλ */
				    l=wn; hantei=0;
				} else {
				    /* ƱIDľϡǽΤ*/
				    /* å³ */
				    hantei = 1;
				}
			    }
			}
			/*
			 * ID kƤιˤĤƥåäˡ
			 * Ƚ꤬1 ǤСID kϢ ID jϢ
			 * ʬǤ롥ϢƱξ
			 * ƱΨʤΤǤΤޤ޻Ĥ
			 */
			if (hantei == 1 &&
			    cwmatrix[j].sum > cwmatrix[k].sum) { 
			    /* ιԤˤidϤ٤ƾä */
			    for (l=0; l<wn; l++)
				cwmatrix[k].entity[l] = 0;
			    cwmatrix[k].sum = 0;
			}
		    }
		}
	    }
	}
    }
}

/*
 * åˤʸ̮ۣͤ ᥤ
 */
STACK* text_level_disamb(sn, wn, idnum, StackTopPoint)
     int  sn;
     int  wn;
     int  idnum;
     STACK *StackTopPoint;
{
	int i, j, state, tmpid[IDN], tmpidno, wordpos, count;
	int StCtinLoop, first;
	/*unsigned char wordinfo[(INFOMAXLEN*SENSEMAXNUM)/2]; /* 10000../2*/
	unsigned char *wordinfo;
	STACK  *nowstack, *oldtop, *st, *upstack, *downstack;
	IDLIST *nowidlist, *preidlist, *nextidlist,
	*p, *q, *idlisttop, *idlistlast;
	WORDLIST *wl, *wordlistlast;
	WORDINFO *wi;
	WINFOLIST *wil, *wil2, *willast;

	if ((wordinfo=(unsigned char *)calloc((size_t)(SENSEMAXNUM*INFOMAXLEN)/2,
					      sizeof(char)))==NULL) {
		fprintf(stderr, "wordinfo\n");
		exit(1);
	}

	state = tmpidno = 0; first=0;
	/* 1ʸñˤĤƽ˸Ƥ */
	for (i=0; i<wn; i++) {                     /* 1wordȽ */
		wordpos = sn*MAXWORDNUM+i+1;/*uniqueֹ꿶 */
		first=0;
		for (j=0; j<idnum; j++) {              /* ƳǰID򸫤Ƥ*/
			if (cwmatrix[j].entity[i] == 1) {  
				if (ciw_sw && first==0) {
					wi = cwmatrix[j].info[i];
					wordpos = wi->realsn * MAXWORDNUM
					     + wi->realwn;
					wi=NULL;
					first=1;
				}

				tmpid[tmpidno] = j;  /* word i λäƤ */
				tmpidno++;               /* IDȤäƤ */
				cwmatrix[j].entity[i] = 0;
			}
			if (i==0) cwmatrix[j].sum = 0;
		}
		nowstack = StackTopPoint;
		state = 0;                    /* stateϤΥå
						 ҥåȤɤ򵭤*/
		/*	StCtinLoop = 0;  /* ǥХå */
		wordinfo[0]='\0';
		while (nowstack != NULL) {
			nowidlist = nowstack->idlist_top;
			while (nowidlist!=NULL) {
				for (j=0; j<tmpidno; j++) {

/*					printf ("cwmatrix[tmpid[%d]].id= %s\n",
						j, cwmatrix[tmpid[j]].id);
					fflush(stdout);
					printf ("nowidlist=%p, nowidlist->id=%s\n",
						nowidlist, nowidlist->id);
					fflush(stdout);
*/
					if (strcmp(cwmatrix[tmpid[j]].id,
						   nowidlist->id)==0) {
						/* IDĤ */
						nowidlist->forcheck = 1;
						wi=cwmatrix[tmpid[j]].info[i];
						willast=
						     nowidlist->winfolist_last;
						
						if (willast == NULL) {
							fprintf(stderr,	"??? willast=NULL??\n");
							exit(1);
						}
						if ((wil=calloc((size_t)1, sizeof(WINFOLIST)))==NULL) {
							fprintf (stderr, "Memory over\n"); exit(1);
						}
						sprintf (wil->wordinfo, "%s]", wi->info);
						strcpy (wil->concept, wi->concept);
						wil->backward_point = willast;
						wil->forward_point = NULL;
						willast->forward_point = wil;
						nowidlist->winfolist_last = wil;
						state++; j = tmpidno;
						wordinfo[0]='\0';
					}
					fflush(stdout);
				}
				nowidlist = nowidlist->forward_point;
			}
			if (state>=1) {  /* stack pointǥޥåID */

				/*
				 * wordlistι -ꥹȤκǸ˺wordɲ- 
				 */
				wordlistlast = nowstack->wordlist_last;
				if ((wl=calloc((size_t)1, sizeof(WORDLIST)))==NULL) {
					fprintf(stderr, "Memory over!!\n"); exit(1);
				}
				wl->wordposition = wordpos;
				strcpy(wl->word, word[i]);
				strcpy(wl->joshi, joshi[i]);
				strcpy(wl->joswd, joswd[i]);
				wl->wnum = wnum_total;
				wnum_total++;
				wl->backward_point = wordlistlast;
				wl->forward_point = NULL;
				wordlistlast->forward_point = wl;
				nowstack->wordlist_last = wl;   /* stackξ󹹿 */
				
				/*
				 * idlistι - ʤ(forcheck=0)ΥꥹȤ -
				 */
				nowidlist = nowstack->idlist_top;
				preidlist = NULL;
				while (nowidlist!=NULL) {
					nextidlist = nowidlist->forward_point;
					preidlist  = nowidlist->backward_point;
					if (nowidlist->forcheck == 0) { /* ä */
						/* listtop㤦 */
						if (nowstack->idlist_top ==	nowidlist) {
							nowstack->idlist_top =  nextidlist;
							nextidlist->backward_point = NULL;
						} else {
							if (nextidlist != NULL) {
								preidlist->forward_point   = nextidlist;
								nextidlist->backward_point = preidlist;
							} else {
								preidlist->forward_point   = NULL;
							}
						}
						wil = nowidlist->winfolist_top;
						while (wil!=NULL) {
							wil2 = wil->forward_point;
							free(wil); wil=NULL;
							wil = wil2;
						}
						free(nowidlist); nowidlist=NULL; /* free */
					} else {
						nowstack->idlist_last = nowidlist;
						nowidlist->forcheck = 0;  /* check򸵤᤹ */
					}
					nowidlist = nextidlist;
				}

		/*
		 * å̤촹
		 */
		
		if (nowstack!=StackTopPoint) { /* topʤ촹ʤ */
		    /* 촹˴ط 4Ĥstack */
		    oldtop         = StackTopPoint;
		    upstack        = nowstack->upward_point;
	         /* nowstack       = nowstack; */
		    downstack      = nowstack->downward_point;
		
		    /* ޤnowstackڤΥƾ岼 */
		    if (downstack == NULL)    /* nowstackλ */
			upstack->downward_point = NULL;
		    else {                    /* Ǥʤо岼 */
			upstack->downward_point = downstack;
			downstack->upward_point = upstack;
		    }
		    
		    /* nowstack ־˻äƤ */
		    oldtop->upward_point     = nowstack;
		    nowstack->upward_point   = NULL;
		    nowstack->downward_point = oldtop;
		    StackTopPoint            = nowstack; /* top */
		}
		break;    /* ()ΥåǤ򸫤˹Ԥɬפʤ */
	    } else {
		nowstack = nowstack->downward_point;
	    }
	}
	/* åΤɤˤƤϤޤʤϿˤĤä
	 * åΥȥå(ꥹȤκǸ)ˤ
	 */
	if (state == 0) {

	    /* wordlist */
		if ((wl=calloc((size_t)1, sizeof(WORDLIST)))==NULL) {
			fprintf(stderr, "Memory over!!\n"); exit(1);
		}
		wl->wordposition = wordpos;
/*		StrCpy(word[i],  wl->word);
		StrCpy(joshi[i], wl->joshi);*/
		strcpy(wl->word, word[i]);
		strcpy(wl->joshi, joshi[i]);
		strcpy(wl->joswd, joswd[i]);

		wl->wnum = wnum_total;
		wnum_total++;
		wl->backward_point = NULL;
		wl->forward_point = NULL;

		/* stack1(idlist) */
		for (j=0; j<tmpidno; j++) {
			if ((p=calloc((size_t)1, sizeof(IDLIST)))==NULL) {
				fprintf(stderr, "Memory over for newIDLIST!!\n");
				exit(1);
			}
/*			StrCpy(cwmatrix[tmpid[j]].id,p->id);*/
			strcpy(p->id, cwmatrix[tmpid[j]].id);
			wi = cwmatrix[tmpid[j]].info[i];
			if ((wil=calloc((size_t)1, sizeof(WINFOLIST)))==NULL) {
				fprintf (stderr, "Memory over\n");
				exit(1);
			}
			sprintf(wil->wordinfo, "%s]", wi->info);
/*			StrCpy (wi->concept, wil->concept);*/
			strcpy (wil->concept, wi->concept);
			wil->backward_point = NULL;
			wil->forward_point  = NULL;
			p->winfolist_top    = wil;
			p->winfolist_last   = wil;
			wordinfo[0]='\0';

			p->forcheck = 0;
			if (j==0) {                 /* ֺǽ㤦 */
				p->backward_point = NULL;
				idlisttop = p;  /* stackϿ뤿¸ */
			} else {
				q->forward_point  = p;
				p->backward_point = q;
			}
			p->forward_point = NULL;
			q = p;
		}
		idlistlast = p;                 /* stackϿ뤿¸ */
		p->forward_point = NULL;
	    
		/* stackǤ */
		if ((st=calloc((size_t)1, sizeof(STACK)))==NULL) {
			fprintf(stderr, "Memory over for newSTACK!!\n");exit(1);
		}
		st->upward_point   = NULL;
		st->wordlist_top   = wl;        /* ǽƬȽ꤬Ʊ */
		st->wordlist_last  = wl;        
		st->idlist_top     = idlisttop;
		st->idlist_last    = idlistlast;
		st->downward_point = StackTopPoint;
		if (StackTopPoint!=NULL) StackTopPoint->upward_point = st;
		StackTopPoint = st;
	}
		for (j=0; j<tmpidno; j++)  tmpid[j]=0;
		tmpidno = 0;
	}
	free(wordinfo);wordinfo=NULL;
	return StackTopPoint;
}
/*
 * sentence levelۣäǻȤǡν
 */
void clear_sentence(idn, wn)
    int idn;
    int wn;
{
    int i, j, k;
    WORDINFO *wi, *wio;

    for (i=0; i<wn; i++) {
	word[i][0]  = '\0';
	joshi[i][0] = '\0';
	joswd[i][0] = '\0';
    }
    wi = WordInfoStart;
    while (wi!=NULL) {
	wio=wi;
	wi=wio->next;
	free(wio); wio=NULL;
    }
    WordInfoStart=NULL;
}

/*
 * 99/07/02 ºݤθֹ椬ϤǤ褦ѹ
 * 01/04...Ϥѹ
 */
void PrintChains (StackTopPoint)
     STACK *StackTopPoint;
{
    int i, j, wordposition, k, sn,wn, mem, idct;
    unsigned char Word[WC], *Buffer;
    STACK    *now;
    WORDLIST *wl;
    IDLIST   *id;
    WINFOLIST *wil;

    if ((Buffer=calloc((size_t)SENSEMAXNUM*INFOMAXLEN, sizeof(char)))==NULL) {
	    fprintf (stderr, "Memory Short!\n");
	    exit(1);
    }

    k=mem=idct=0;
    Buffer[0]='\0';
    now = StackTopPoint;
    while (now != NULL) {
	k++;
	id = now->idlist_top;
	while (id != NULL) {
	    idct++;
	    wl = now->wordlist_top;
	    wil = id->winfolist_top;
	    while (wil!=NULL) {
		mem++;
		sn = (wl->wordposition)/1000;/******error**/
		wn = (wl->wordposition)-(sn*1000);

		if (Buffer[0]=='\0') {
		    if (SIMPLE_OUTPUT==ON)
/*			sprintf(Buffer, "%s %d %d %s\n",
				wl->word, sn, wn, wl->joshi);
*/
			sprintf(Buffer, "%d %d %d %s %s %s %s\n",
				sn, wn, wl->wnum, wil->concept,
				wl->word, wl->joshi, wl->joswd);
		    else
			sprintf(Buffer, "(%s,%d,%d),%s),%s,%s\n",
				wl->word, sn, wn,
				wil->wordinfo, wl->joshi, wl->joswd);
		} else if(strcmp(wl->word, "")!=0){
		    /* Х  wl->wordʤˤʤǤϤʤϤʤΤ */
		    if (SIMPLE_OUTPUT==ON)
/*			sprintf(Buffer, "%s%s %d %d %s\n",
				Buffer, wl->word, sn, wn, wl->joshi);
*/
			sprintf(Buffer, "%s%d %d %d %s %s %s %s\n", Buffer, sn, wn,
				wl->wnum, wil->concept, wl->word, wl->joshi, wl->joswd);
		    else
			sprintf(Buffer, "%s(%s,%d,%d),%s),%s,%s\n", 
				Buffer, wl->word, sn, wn,
				wil->wordinfo, wl->joshi,wl->joswd);
		}
		wil = wil->forward_point;
		wl = wl->forward_point;
	    }
	    id = id->forward_point;
	    if (mem >= CHNMEM_THRESH) /* CHNMEM_THRESHʾθɽ */
		printf ("%s\n", Buffer);
	    mem=0;
	    Buffer[0]='\0';
	    if ((ONLY_ONE_SENSE==ON) && idct==1) break;
	}
	now = now->downward_point;
	idct=0;
    }
    free (Buffer); Buffer=NULL;
}

/*
 * 99/07/02 ºݤθֹ椬ϤǤ褦ѹ
 *
 * 99/11/25 2ϰŪǤϤꥢ㤦
 */
void PrintChains2 (StackTopPoint)
     STACK *StackTopPoint;
{
    int i, j, wordposition, k, sn,wn, mem, idct;
    unsigned char Word[WC], *Buffer;
    STACK    *now, *bak;
    WORDLIST *wl, *bwl;
    IDLIST   *id, *bid;
    WINFOLIST *wil, *bwil;

    if ((Buffer=calloc((size_t)SENSEMAXNUM*INFOMAXLEN, sizeof(char)))==NULL) {
	    fprintf (stderr, "Memory Short!\n");
	    exit(1);
    }

    k=mem=idct=0;
    Buffer[0]='\0';
    now = StackTopPoint;
    while (now != NULL) {
	k++;
	id = now->idlist_top;
	while (id != NULL) {
	    idct++;
	    wl = now->wordlist_top;
	    wil = id->winfolist_top;
	    while (wil!=NULL) {
		mem++;
		sn = (wl->wordposition)/1000;
		wn = (wl->wordposition)-(sn*1000);

		if (Buffer[0]=='\0') {
		    if (SIMPLE_OUTPUT==ON)
			sprintf(Buffer, "%d %d %d %s %s %s %s\n",
				sn, wn, wl->wnum, wil->concept,
				wl->word, wl->joshi, wl->joswd);
		    else
			sprintf(Buffer, "(%s,%d,%d),%s),%s,%s\n",
				wl->word, sn, wn,
				wil->wordinfo, wl->joshi,wl->joswd);
		} else if(strcmp(wl->word, "")!=0){
		    /* Х  wl->wordʤˤʤǤϤʤϤʤΤ */
		    if (SIMPLE_OUTPUT==ON)
			sprintf(Buffer, "%s%d %d %d %s %s %s %s\n", Buffer, sn, wn,
				wl->wnum, wil->concept,
				wl->word, wl->joshi, wl->joswd);
		    else
			sprintf(Buffer, "%s(%s,%d,%d),%s),%s,%s\n", 
				Buffer, wl->word, sn, wn,
				wil->wordinfo, wl->joshi, wl->joswd);
		}
		bwil=wil;
		wil = wil->forward_point;
		bwl=wl;
		wl = wl->forward_point;

		free(bwil); bwil=NULL;
		free(bwl);  bwl=NULL;
	    }
	    bid=id;
	    id = id->forward_point;

	    free(bid); bid=NULL;

	    if (mem >= CHNMEM_THRESH) /* CHNMEM_THRESHʾθɽ */
		printf ("%s\n", Buffer);
	    mem=0;
	    Buffer[0]='\0';
	    if ((ONLY_ONE_SENSE==ON) && idct==1) break;
	}
	bak = now;
	now = now->downward_point;
	idct=0;
	free(bak); bak=NULL;
    }
    free (Buffer); Buffer=NULL;
}

STACK* make_chain (StackTopPoint,dptr)
   STACK *StackTopPoint;
   char *dptr;
{
	int  snum, psnum, i, j;
	char record[1024];
	unsigned char cats[1024],ppinfo[JOSHIMAXLEN],term[TERMMAXLEN],psuf[JOSHIMAXLEN];
	int nowwnd, nowsn, presn, nowwn, prewn, idnum;

	SPENDHASH = nowwn = 0;
	idnum = 0;
	for (i=0; dptr[0]!='\0'; i++) {
		record[0]='\0';
		splitdata(record, dptr, '\n');
		/* Ǥ1ѹ 01.04.29 */
		sscanf (record, "%s\t%d\t%d\t%s\t%s\t%s\n",
			term, &nowsn, &nowwnd, cats, ppinfo, psuf);
		nowwn++;
		idnum = word_level(term,nowsn,nowwn,cats,idnum,ppinfo,nowwnd,psuf);
		presn = nowsn;
		prewn = nowwn;
		/*
		  printf ("idnum = %d\n", idnum);
		  */
	}
	sentence_level_disamb(prewn, idnum); /* 1ʸǤۣ */
	StackTopPoint =
	     text_level_disamb(presn, prewn, idnum, StackTopPoint);
	clear_sentence(idnum, prewn);
	clear_hash();
	SPENDHASH = 0;
	/*free(categories); categories=NULL;*/
	return StackTopPoint;
}


/*
 * 귿Τ褦ʤΤǡmain餳Ƥ٤Ф褦ˤޤȤƤߤ
 *
 * 
 */
void chaining_preparation()
{
	WordInfoStart=NULL;
	clear_sentence(IDN, WN);
	StackTopPoint = NULL;
	wnum_total = 1;
	init_hash();
}
