/*
 * chnfil.c
 *
 * Copyright (c) 2001 Hajime Mochizuki <motizuki@jaist.ac.jp>
 *   Natural Language Processing Laboratory,
 *   Japan Advanced Institute of Science and Technology.
 *
 *
 * Use of this software is granted only for RESEARCH PURPOSES. 
 * Redistribution is granted as long as all copyright notices are retained.
 * Redistribution with modification is allowed provided that you make your 
 * modified version obviously distinguishable from the original one.  
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR 
 * IMPLIED WARRANTIES ARE DISCLAIMED.
 *
 *
 */
#include <config.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* #include "cmn.h"*/

#include "chnfil.h"
/* #include "cdef_rule.h" */ /* -DDEF_WRULE_POS=\"$(pkgdatadir)/rules\" */

struct ppw_rl *pwrl=NULL;

/*
 * chn_ana 
 */
struct chn_ana* cal_chn_ana (num)
     int num;
{
        struct chn_ana *ca;

        if ((ca=calloc(num, sizeof(*ca)))==NULL) {
                fprintf (stderr, "calloc for ca error\n");
                exit(1);
        }
        return ca;
}

struct chn_ana* ral_chn_ana (ca, to)
     struct chn_ana *ca;
     int to;
{
        struct chn_ana *tmp;
        
        if ((tmp=realloc(ca, sizeof(*tmp)*to))==NULL) {
                fprintf (stderr, "realloc error for cp\n");
                exit(1);
        }
        return tmp;
}


void set_ppw_rules (mrp_type, mrf)
     int mrp_type;
     char *mrf;
{
	int i, soeji, wrls, sz;
	FILE *fp;
	char mrl[200], d[3][CHNPOSTPMAXLEN], buf[BUFSIZ];
	struct chn_ana *ca;
	
	if (mrf==NULL) { /* ľܤΥե꤬ʤ */
	       switch (mrp_type) {
	       case 0:
                        sprintf(mrl, "%s/wrule0", DEF_WRULE_POS);
                        break;
	       case 1:
	       case 2:
                        sprintf(mrl, "%s/wrule1", DEF_WRULE_POS);
                        break;
	       case 3:
                        sprintf(mrl, "%s/wrule3", DEF_WRULE_POS);
                        break;
                case 4:
                        sprintf(mrl, "%s/wrule4", DEF_WRULE_POS);
                        break;
                default:
                        sprintf(mrl, "%s/wrule0", DEF_WRULE_POS);
                        break;
                }
        } else {
                sprintf (mrl, "%s", mrf);
        }
        if ((fp=fopen(mrl, "r"))==NULL) {
                fprintf (stderr, "cannot open %s\n", mrl);
                exit(1);
        }
        if ((pwrl=calloc(1,sizeof(*pwrl)))==NULL) {
                fprintf (stderr, "calloc for pwrl error\n");
                exit(1);
	}
	for (i=0; i<1; i++) {        /* ΤȤ P 1ĤȤͽ꤬ʤ */
		pwrl[i].word[0]='P';
		pwrl[i].word[1]='\0';
		pwrl[i].rule_ct=0;
		pwrl[i].ca=NULL;
	}
	soeji=0; wrls=0;
	while(fgets(buf, BUFSIZ, fp)!=NULL) {
		if(buf[0]=='#') continue;/*  */
                buf[strlen(buf)-1]='\0';
		for (i=0; buf[0]!='\0'; i++) {
			d[i][0]='\0';
			splitdata(d[i], buf, '\t');
		}
		if (wrls==0) {
			ca = cal_chn_ana(CHNPPWADD);
			sz = CHNPPWADD;
		} else if (wrls>=sz) {
			ca = ral_chn_ana(ca, sz+CHNPPWADD);
			sz+= CHNPPWADD;
		}
		ca[wrls].wgt = atof(d[0]);
		strcpy(ca[wrls].pptype, d[1]);
		strcpy(ca[wrls].ppword, d[2]);
		wrls++;
	}
	pwrl[soeji].rule_ct= wrls;
	pwrl[soeji].ca = ca;
}

/*
 * sscanf ߤʽ
 * lexical chainers Υǡΰ㤤ۼǤ褦ˡ˵Ҥ롥
 */
struct chn_entry* chn_sscanf(record, chn_type)
     char *record;
     int chn_type;
{
        int i, j, s, w, n;
        struct chn_entry *ce;

        if ((ce=calloc(1,sizeof(*ce)))==NULL) {
                fprintf (stderr, "calloc for ce error\n");
                exit(1);
        }
        for (i=0; i<(CHNFIELDMAX-3); i++) ce->field[i][0]='\0';
	ce->sn=-1; ce->wn=-1; ce->wnum=-1;

        switch (chn_type) { /* 뤫ʤǡեɤο㤦 */
        case CHNTYPE_THESAURUS:
		sscanf (record, "%d %d %d %s %s %s %s\n", &s, &w, &n, 
			ce->field[0], ce->field[1], ce->field[2], ce->field[3]);
		ce->sn = s; ce->wn = w; ce->wnum =n;
                break;
	case CHNTYPE_COOCCURRENCE:
		sscanf (record, "%d %d %d %s %s %s\n", &s, &w, &n,
			ce->field[1], ce->field[2], ce->field[3]);
		ce->field[0][0]='\0';
		ce->sn = s; ce->wn = w; ce->wnum =n;
		break;
	}
	return ce;
}

/* դǤνŤߤ */
double get_postp_weight (pptype, ppword)
     char *pptype, *ppword;
{
	int i;
	struct chn_ana *ca;

	for (i=0; i<pwrl[0].rule_ct; i++) {
		ca = (pwrl+0)->ca+i;
		if ((strcmp(pptype, ca->pptype)==0) &&
		    (strcmp(ppword, ca->ppword)==0)) {
			return ca->wgt;
		}
	}
	return (double)1.0; /* פʤȤŤߤʤ */
}
