/*
 * tools.c
 *
 * Copyright (c) 1997-1999,2000,2001 Hajime Mochizuki <motizuki@jaist.ac.jp>
 *   Natural Language Processing Laboratory,
 *   Japan Advanced Institute of Science and Technology.
 *
 *
 * Use of this software is granted only for RESEARCH PURPOSES. 
 * Redistribution is granted as long as all copyright notices are retained.
 * Redistribution with modification is allowed provided that you make your 
 * modified version obviously distinguishable from the original one.  
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR 
 * IMPLIED WARRANTIES ARE DISCLAIMED.
 *
 */
#include <config.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#ifndef OFFSET
#define OFFSET 0
#endif

void StrCpy (cp1, cp2)
     unsigned char *cp1;
     unsigned char *cp2;
{
    int i;

    i = 0;
    while (cp1[i]!=0 && cp1[i]!='\n') {
	cp2[i] = cp1[i++];
    }
    cp2[i] = 0;
}
    
int StrLen (st)
    unsigned char *st;
{
    int i;

    i = 0;
    while (st[i]!=0 && st[i]!='\n') i++;
    return(i);
}

void ClrStr (data, n)
     unsigned char *data;
     int n;
{
    int i;

    for (i=0;i<n;i++) data[i] = 0;
}

int InString (word, data, offset)
    unsigned char *word;
    unsigned char *data;
    int offset;
{
    unsigned char cs[20];
    int i,j,k,len;

/*    if (StrLen(data)>StrLen(word)) return(-1);*/
    if (strlen(data)>strlen(word)) return(-1);
    i   = offset;
/*    len = StrLen(data);*/
    len = strlen(data);
    while (word[i]!='\0') {
	for (k=0;k<len;k++) cs[k] = word[i+k];
	cs[len] = 0;
	if  (ChkStr(cs,data)) return(i);
	else i++;
    }
    return(-1);
}

void CutStrPart (word, w1, w2)
     unsigned char *word;
     unsigned char *w1;
     unsigned char *w2;
{
    int i1,i2,p1,p2;

    p1 = p2 = OFFSET;
/*    for (;;) {*/
    p1 = InString(word,w1,p1);
    p2 = InString(word,w2,p2);

/*    if(p1==-1 || p2==-1) break; /* w1,w2ʸˤʤν */
    if(p1==-1 || p2==-1) return;
     /*	while(p2<p1){                  w2 νи֤w1ν 
	    p2=InString(word,w2,p2);
	} */
    i1 = p1; i2 = p2+2;         /* ʸ򥫥åȤʬ */
    while (word[i2]!='\0' && word[i2]!='\n') {
	    word[i1++] = word[i2++];
    }
    word[i1]='\0';
    /*    }*/
}

void RemoveWord (word, w)
     unsigned char *word;
     unsigned char *w;
{
    int i,point,len,len1;

    len = StrLen(w);
    while (InString(word,w,OFFSET)!=-1) {
	point = InString(word,w,OFFSET);
	len1  = StrLen(word);
	for (i=point+len;i<len1;i++) word[point++] = word[i];
	word[point] = 0;
    }
}

/* ĤʸȤ߹碌ơʸ 
 *                 s3 = s1 + s2                   
 */
void ConnectStr (s1, s2, s3)
     unsigned char *s1;
     unsigned char *s2;
     unsigned char *s3;
{
    int i,j;

    i = j = 0;
    while (s1[i]!=0) s3[j++] = s1[i++];
    i = 0;
    while (s2[i]!=0) s3[j++] = s2[i++];
    s3[j] = 0;
}

/****************************************************************/
/*								*/
/*  splitؿ							*/
/*		src	  : ʬ䤹ʸ		*/
/*			dst	  : ʬη̤	*/
/*			separator : ѥ졼Ȥʤʸ	*/
/*								*/
/****************************************************************/
int Split (src, dst, separator )
    unsigned char* src;
    unsigned char  dst[150][1000];
    unsigned char *separator;
{
    int	     number_of_token,sep_length,point,point1,i;/* ȡο */
    unsigned char temp[10];
    unsigned char buffer[4000];

    /*  */
    number_of_token = 0;

    /* ѥ졼ȤʤʸĹ */
    sep_length = StrLen(separator);

    /* ʸΥå */
    if ((src == NULL)||(*src == '\0')) return 0;
    if ( StrLen(src) >= 4000 )
	 fprintf( stderr, "split: source string too long.\n" ); 


    /* ʸνˤʤޤǥ롼פäñ򽸤 */
    point=0;
    while( src[point] != '\0' ) {
	for(i=0;i<sep_length;i++) temp[i]=src[point+i];
	temp[i]=0;

	/* ʸˤޤѥ졼뤫 */
	point1=0;
	while (!ChkStr(temp,separator) && src[point]!=0) {
	    for (i=0;i<sep_length;i++) 
		 dst[number_of_token][point1++] = src[point++];
	    for (i=0;i<sep_length;i++)  temp[i] = src[point+i];
	    temp[i]=0;
	}
	dst[number_of_token][point1] = 0;

	if (src[point]==0) break;
	else {
	    point+=sep_length;
	    number_of_token++;
	}
    }

    return (number_of_token+1);
}

int power (i)
    int i;
{
    int j,n;
    
    n=1;
    if (i==0)              return(1);
    else for (j=0;j<i;j++) n = n*10;
    return(n);
}


int ChkStr (cmp1, cmp2)
    unsigned char *cmp1;
    unsigned char *cmp2;
{
    int p;

    if (StrLen(cmp1)!=StrLen(cmp2)) return(0);  
    p = 0;
    while  (cmp1[p]!=0 && cmp1[p]!='\n') {
        if (cmp1[p]!=cmp2[p]) return(0);
        p++;
    }
    return(1);
}

	
int NthInString (op, s1, s2)
    int op;
    unsigned char *s1;
    unsigned char *s2;
{
    int p,l,i;
    unsigned char cs[5];

    if (StrLen(s2)>StrLen(s1)) return(-1);
    l = StrLen(s2);
    p = 0;
    while (s1[p]!=0 && s1[p]!='\n') {
	for (i=0;i<l;i++) cs[i] = s1[p+i];
	cs[l] = 0;
	if (ChkStr(s2,cs)) {
	    if  (op==1) return(p);
	    else op--;
	}
	p+=2;
    }
    return(-1);
}

int RemoveCharFromHead(word, source)
    unsigned char *word;
    unsigned char *source;
{
    int len,point;

    if (StrLen(source)>StrLen(word)) return(-1);
    while (InString(word,source,OFFSET)==0) {
	len   = StrLen(source);
	point = 0;
	while (word[point+len]!=NULL && word[point+len]!='\n') {
	    word[point] = word[len+point];
	    point++;
	}
	word[len+point] = 0;
    }
    return(0);
}

int StrInStr (str1, str2)
    unsigned char *str1;
    unsigned char *str2;
{
    int i,WordNumber;
    unsigned char word[150][1000];

    WordNumber = Split(str1,word,"");
    for (i=0;i<WordNumber;i++) {
	if (ChkStr(word[i],str2)) return(1);
    }
    return(0);
}

int StrInStr2 (str1, str2)
    unsigned char *str1;
    unsigned char *str2;
{
    int i,WordNumber;
    unsigned char word[150][1000],word1[152],word2[152];

    WordNumber = Split(str1,word,"");
    ConnectStr("\"",str2,word1);
    ConnectStr(word1,"\"",word2);
    for (i=0;i<WordNumber;i++) {
	if (ChkStr(word[i],word2)) return(1);
    }
    return(0);
}

/*
 * ʸ"word"ˤʸ"source"ʸ"des"֤
 *                 ٤ƤʸĹ¤ʤ               
 */
int ChangeWord (word, source, des)
    unsigned char *word;
    unsigned char *source;
    unsigned char *des;
{
    unsigned char temp[1024];
    int i,p,point,len,len1,len2,flag;

    len1  = StrLen(des);
    len   = StrLen(source);
    point = 0; flag = 0;
    while (InString(word,source,OFFSET)!=-1) {
	flag  = 1;
	point = InString(word,source,OFFSET);
	ClrStr(temp,1024);
	p = 0;
	for (i=0;i<point;i++) temp[p++] = word[i];
	for (i=0;i<len1;i++)  temp[p++] = des[i];
	len2 = StrLen(word);
	for (i=point+len;i<len2;i++) temp[p++] = word[i];
	temp[p] = NULL;
	StrCpy(temp,word);
    }
    if (flag) return(1);
    else      return(0);
}

void GetFollowStr (field, temp, sep, num)
     unsigned char *field;
     unsigned char *temp;
     unsigned char *sep;
     int num;
{
    int point,point1,p;
    unsigned char cs[3];

    p     = 0;
    point = 0;
    while (p<num) {
	cs[0] = field[point++]; cs[1] = field[point++]; cs[2] = 0;
	if (ChkStr(cs,sep))	p++;
    }
    point1 = 0;
    while (field[point]!=0) temp[point1++] = field[point++];
    temp[point1] = 0;
}
