/*
 * libnero.c
 * Copyright (c) 1998-2000,2001 Hajime Mochizuki <motizuki@jaist.ac.jp>
 *   Natural Language Processing Laboratory,
 *   Japan Advanced Institute of Science and Technology.
 *
 *
 * Use of this software is granted only for RESEARCH PURPOSES. 
 * Redistribution is granted as long as all copyright notices are retained.
 * Redistribution with modification is allowed provided that you make your 
 * modified version obviously distinguishable from the original one.  
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR 
 * IMPLIED WARRANTIES ARE DISCLAIMED.
 *
 * patrash˸ƤӤ餦
 *
 */
#include <config.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
/*#include "coidxr.h"*/
#include "patrash.h"
#include "nero.h"

#ifndef WDMAX
#define WDMAX 500
#endif

#ifndef _MERROR_
#define _MERROR_


/* */
void free_patrash_answer_ptr (p)
     struct patrash_answer_ptr *p;
{
	free(p->ptr); p->ptr=NULL;
	free(p); p=NULL;
}

int fopen_dic_check (fn)
     char *fn;
{
	char dicf[200];
	FILE *f;
	sprintf (dicf, "%s.dat", fn);

	if ((f=fopen(dicf, "r"))==NULL) {
		return 0;
	} else {
		fclose(f);
		return 1;
	}
}

void merror (comment)
   char *comment;
{
	fprintf (stderr, "calloc error for %s\n", comment);
	exit(1);
}
#endif

FILE *open_dic (fn)
     char *fn;
{
	char dicf[200];
	FILE *f;

	sprintf (dicf, "%s.dat", fn);
	if ((f=fopen(dicf, "r"))==NULL) {
		perror("cannot open dicfile\n");
		exit(1);
	}
	return f;
}

FILE *open_patrash_idx (s)
     char *s;
{
	FILE *f;
	char fn[PATRA_FILE_LEN];
	
	sprintf (fn, "%s.idx", s);
	if ((f = fopen (fn, "rb"))==NULL) {
		fprintf (stderr, "cannot open %s\n", fn);
		exit(1);
	}
	return f;
}

FILE *open_patrash_wan (s)
     char *s;
{
	FILE *f;
	char fn[PATRA_FILE_LEN];

	sprintf (fn, "%s.wan", s);
	if ((f = fopen (fn, "rb"))==NULL) {
		fprintf (stderr, "cannot open %s\n", fn);
		exit(1);
	}
	return f;
}

struct patrash_array *read_patrash_idx (f)
      FILE *f;
{	
	int i;
	struct patrash_array *tmp, *pa;
	
	if ((tmp = calloc((size_t)1, sizeof(*tmp)))==NULL)
	    merror ("tmp");
	
	rewind(f);
	if (fread(tmp, sizeof(struct patrash_array), (size_t)1, f)!=1) {
		perror ("fread");
		exit(1);
	}
/*	fprintf(stderr, "tmp .. %d %d %d %p\n",
		tmp->pos, tmp->zero, tmp->one, tmp->ptr);
*/

	if ((pa = (struct patrash_array *)calloc((size_t)tmp->pos+1, sizeof(*pa)))
	    ==NULL) merror ("pa");

	memcpy (&pa[0], tmp, sizeof(tmp));

	for (i=1; i<=pa[0].pos; i++) {
		if (fread(&pa[i], sizeof(struct patrash_array),(size_t)1, f)!=1) {
			perror ("fread");
			exit(1);
		}
	}
	free (tmp); tmp=NULL;
	return pa;
}

/*
 * patrashѲǽˤ뤿νޤȤ᤿ؿ
 */
struct patrash_files* patrash_preparation (fn)
     char *fn;
{
	struct patrash_files *pf;
	FILE *pidx;

	if((pf=calloc((size_t)1, sizeof(pf)))==NULL) {
		perror("calloc pf");
		exit(1);
	}
	pidx = open_patrash_idx (fn);
	pf->wan = open_patrash_wan (fn);
	pf->pa = read_patrash_idx (pidx);
	fclose(pidx);

	return pf;
}
	
void patrash_finish (pa)
    struct patrash_files *pa;
{
	fclose (pa->wan);
}


char* search_dicinfo (ptrr, dic)
     struct patrash_answer_ptr *ptrr;
     FILE *dic;
{
	int i, j, dicinfo_size;
	char tmp_word[200], *dicinfo, *tmp;

	dicinfo=NULL;
	dicinfo_size=0;
	for (i=0; i<ptrr->pf; i++) {
		if (fseek (dic, (size_t)ptrr->ptr[i], SEEK_SET)==-1) {
			perror ("dic seek");
			exit(1);
		}
		j = 0;
		tmp_word[0]='\0';
                while (fread(&tmp_word[j], sizeof(char), 1, dic)==1) {
                        if (tmp_word[j]=='\0') break;
                        j++;
                }
                sprintf (tmp_word, "%s\n", tmp_word);
                if (dicinfo==NULL) {
                        dicinfo = strdup(tmp_word);
			dicinfo_size = strlen(tmp_word)+1;
                } else {
                        if ((tmp=realloc(dicinfo,
					 dicinfo_size+
					 strlen(tmp_word)))==NULL) {
                                perror ("realloc for dicinfo");
                                exit(1);
                        }
                        dicinfo = tmp;
			dicinfo_size = dicinfo_size+strlen(tmp_word);
                        sprintf (dicinfo, "%s%s", dicinfo, tmp_word);
		}
	}
        return dicinfo;
}

struct dicinfo_id* search_dicinfo_id (ptrr, dic, dictype, lv)
     struct patrash_answer_ptr *ptrr;
     FILE *dic;
     int  dictype, lv;
{
	int i, j, dam;
	char tmp_word[200], word[100], id1[10], id2[5], id3[10], cat[40];
	char other[100], id[25];
	struct dicinfo_id *info;

	info=NULL;
	
	if ((info=calloc((size_t)1, sizeof(*info)))==NULL) {
		perror ("calloc dic info");
		exit(1);
	}
	if ((info->ids=calloc((size_t)ptrr->pf, sizeof(char**)))==NULL) {
		perror ("calloc info->ids");
	}
	for (i=0; i<ptrr->pf; i++) {
		if (fseek (dic, (size_t)ptrr->ptr[i], SEEK_SET)==-1) {
			perror ("dic seek");
			exit(1);
		}
		j = 0;
		tmp_word[0]='\0';
                while (fread(&tmp_word[j], sizeof(char), 1, dic)==1) {
                        if (tmp_word[j]=='\0') break;
                        j++;
                }
                sprintf (tmp_word, "%s\n", tmp_word);

		switch (dictype) {
		   default:
		   case 1: /* kadokawa */
			sscanf(tmp_word, "%s %d %s %s %s %s %s\n",
			       word, &dam, cat, id1, id2, id3, other);
			if (lv==1) {
				strcpy(id, id1);
			} else if (lv==2) {
				sprintf(id, "%s%s", id1, id2);
			} else if (lv==3) {
				sprintf(id, "%s%s%s", id1, id2, id3);
			}
			info->ids[i] = strdup(id);
			break;
		}
	}
	info->n = ptrr->pf;
        return info;
}

struct patrash_answers *get_patrash_wan (word, ptr, pwan)
    char  *word;
    off_t ptr;
    FILE  *pwan;
{
	int  i;
	char tmp_word[WDMAX];
	struct patrash_answers *patans;

	if (fseek (pwan, (size_t)ptr, SEEK_SET)==-1) {
		perror ("pwan");
		exit(1);
	}
	i = 0;
	tmp_word[0]='\0';
	while (fread(&tmp_word[i], sizeof(char), 1, pwan)==1) {
		if (tmp_word[i]=='\0') break;
		i++;
	}
	if (strcmp(word, tmp_word)==0) { /* פƤ */
		if ((patans=calloc((size_t)1, sizeof(*patans)))==NULL) merror("patans");
		if (fread(&patans->df, sizeof(int), 1, pwan)!=1) {
			perror("fread patans->df"); exit(1);
		}
/*		printf ("%s, %d\n", tmp_word, patans->df);*/
		if ((patans->sc_ptr=calloc((size_t)patans->df, sizeof(off_t)))==NULL)
		    merror("patans->sc_ptr");
		for (i=0; i<patans->df; i++) {
			if(fread(&patans->sc_ptr[i],sizeof(off_t),(size_t)1,pwan)!=1) {
				perror("fread patans->sc_ptr"); exit(1);
			}
/*			printf ("i=%d, %p\n", i, patans->sc_ptr[i]);*/
		}
/*		if(fread(patans->sc_ptr,sizeof(off_t), (size_t)(patans->df),pwan)!=1) {
			perror("fread patans->sc_ptr"); exit(1);
		}
*/
		return patans;
	} else {
		return NULL;
	}
}

struct patrash_answers *tell_patrash (word, pa, pwan)
     char   *word;
     struct patrash_array *pa;
     FILE   *pwan;
{
	char *word1;
	int i, j, k, x, pos, l;
	struct patrash_answers *patans, *pck;

	j = strlen(word);
	if ((word1=calloc((size_t)j+1, sizeof(char)))==NULL) merror("word1");
	pos = 0;
	l   = 1;
	patans = NULL;
	word1[0]='\0';
	for (i=0; i<j; i++) {
		x = word[i];
		for (k=0; k<8; k++) {
			if (pos == pa[l].pos) {
/*----------------------------------------------------------------------------
				if (pa[l].ptr != (off_t)-1) {
					pck = get_patrash_wan (word1, pa[l].ptr, pwan);
					if (pck!=NULL) {
						pck->no   = i+1;
						pck->next = patans;
						patans    = pck;
					} else {
						free (word1);
						return patans;
					}
				}
----------------------------------------------------------------------------*/
				if (x & (1<<(7-k))) { /* 1 */
					l = pa[l].one;
				} else {              /* 0 */
					l = pa[l].zero;
				}
/*----------------------------------------------------------------------------
				if (l==0) {
					if (pa[l].ptr != (off_t)-1) {
						pck = get_patrash_wan (word1, pa[l].ptr, pwan);
						if (pck!=NULL) {
							pck->no   = i+1;
							pck->next = patans;
							patans    = pck;
						}
					}
					free (word1);
					return patans;
				}
----------------------------------------------------------------------------*/
			}
			pos++;
		}
		word1[i] = word[i];
	}
	if (pa[l].ptr != (off_t)-1) {
		pck = get_patrash_wan (word1, pa[l].ptr, pwan);
		if (pck!=NULL) {
			pck->no   = i+1;
			pck->next = patans;
			patans    = pck;
		}
	}
	free (word1);
	return patans;
}

void print_patrash_wan (pas)
     struct patrash_answers *pas;
{
	int i;

	if (pas==NULL) return;
	printf ("wordposition %d\n", pas->no);
	printf ("word df      %d\n", pas->df);
	printf ("subchn ptrs \n");
	for (i=0; i<pas->df; i++) {
		printf ("\t%d = %p\n", i+1, pas->sc_ptr[i]);
	}
}

struct patrash_answer_char *read_wan_char (word, ptr, fwan)
     char *word;
     off_t ptr;
     FILE *fwan;
{
	int i, c;
	char   tmp_word[WDMAX], *tmp;
	struct patrash_answer_char *pchar;

	if (fseek(fwan, (size_t)ptr, SEEK_SET)==-1) {
		perror("fwan");
		exit(1);
	}
	i = 0;
	tmp_word[0]='\0';
	while(fread(&tmp_word[i], sizeof(char), 1, fwan)==1) {
		if (tmp_word[i]=='\0') break;
		i++;
	}
	if (strcmp(word, tmp_word)==0) {
		if ((pchar=calloc((size_t)1, sizeof(*pchar)))==NULL)
		    merror("pchar");
		if ((pchar->str=calloc((size_t)WDMAX, sizeof(char)))==NULL)
		    merror("pchar->str");
		i=0; c=WDMAX;
		while(fread(&pchar->str[i], sizeof(char), 1, fwan)==1) {
			if (pchar->str[i]=='\0') break;
			i++;
			if (i==c) {
				if ((tmp=realloc(pchar->str, sizeof(char)*(c+WDMAX)))
				    ==NULL) {
					perror("realloc pchar->str");
					exit(1);
				}
				pchar->str = tmp;
				c=c+WDMAX;
			}
		}
		return pchar;
	} else {
		return NULL;
	}
}


struct patrash_answer_int_char *read_wan_int_char(word, ptr, fwan)
     char *word;
     off_t ptr;
     FILE *fwan;
{
	int i, c, num;
	char   tmp_word[WDMAX], *tmp;
	struct patrash_answer_int_char *intchar;

	if (fseek(fwan, (size_t)ptr, SEEK_SET)==-1) {
		perror("fwan");
		exit(1);
	}
	i = 0;
	tmp_word[0]='\0';
	while(fread(&tmp_word[i], sizeof(char), 1, fwan)==1) {
		if (tmp_word[i]=='\0') break;
		i++;
	}
	if (strcmp(word, tmp_word)==0) {
		if ((intchar=calloc((size_t)1, sizeof(*intchar)))==NULL)
		    merror("intchar");
		if(fread(&num, sizeof(int), 1, fwan)!=1) {
			perror("fread intchar->num");
			exit(1);
		}
		intchar->num = num;
		if ((intchar->str=calloc((size_t)WDMAX, sizeof(char)))==NULL)
		    merror("intchar->str 1");
		i=0; c=WDMAX;
		while(fread(&intchar->str[i], sizeof(char), 1, fwan)==1) {
		if (intchar->str[i]=='\0') break;
			i++;
			if (i==c) {
				if ((tmp=realloc(intchar->str, sizeof(char)*(c+WDMAX)))
				    ==NULL) {
					perror("realloc intchar->str");
					exit(1);
				}
				intchar->str = tmp;
				c=c+WDMAX;
			}
		}
		return intchar;
	} else {
		return NULL;
	}
}

struct patrash_answer_int *read_wan_int(word, ptr, fwan)
     char *word;
     off_t ptr;
     FILE *fwan;
{
	int i, c, num;
	char   tmp_word[WDMAX], *tmp;
	struct patrash_answer_int *intr;

	if (fseek(fwan, (size_t)ptr, SEEK_SET)==-1) {
		perror("fwan");
		exit(1);
	}
	i = 0;
	tmp_word[0]='\0';
	while(fread(&tmp_word[i], sizeof(char), 1, fwan)==1) {
		if (tmp_word[i]=='\0') break;
		i++;
	}
	if (strcmp(word, tmp_word)==0) {
		if ((intr=calloc((size_t)1, sizeof(*intr)))==NULL)
		    merror("intr");
		if(fread(&num, sizeof(int), 1, fwan)!=1) {
			perror("fread intr->num");
			exit(1);
		}
		intr->num = num;
		return intr;
	} else {
		return NULL;
	}
}

int read_wan_int2(word, ptr, fwan)
     char *word;
     off_t ptr;
     FILE *fwan;
{
	int i, c, num;
	char   tmp_word[WDMAX], *tmp;

	if (fseek(fwan, (size_t)ptr, SEEK_SET)==-1) {
		perror("fwan");
		exit(1);
	}
	i = 0;
	tmp_word[0]='\0';
	while(fread(&tmp_word[i], sizeof(char), 1, fwan)==1) {
		if (tmp_word[i]=='\0') break;
		i++;
	}
	if (strcmp(word, tmp_word)==0) {
/*		if ((intr=calloc((size_t)1, sizeof(*intr)))==NULL)
		    merror("intr");*/
		if(fread(&num, sizeof(int), 1, fwan)!=1) {
			perror("fread num");
			exit(1);
		}
		return num;
	} else {
		return NULL;
	}
}

struct patrash_answer_double *read_wan_double(word, ptr, fwan)
     char *word;
     off_t ptr;
     FILE *fwan;
{
	int i, c;
	double dbl;
	char   tmp_word[WDMAX], *tmp;
	struct patrash_answer_double *dblr;

	if (fseek(fwan, (size_t)ptr, SEEK_SET)==-1) {
		perror("fwan");
		exit(1);
	}
	i = 0;
	tmp_word[0]='\0';
	while(fread(&tmp_word[i], sizeof(char), 1, fwan)==1) {
		if (tmp_word[i]=='\0') break;
		i++;
	}
	if (strcmp(word, tmp_word)==0) {
		if ((dblr=calloc((size_t)1, sizeof(*dblr)))==NULL)
		    merror("dblr");
		if(fread(&dbl, sizeof(double), 1, fwan)!=1) {
			perror("fread dbl");
			exit(1);
		}
		dblr->dbl = dbl;
		return dblr;
	} else {
		return NULL;
	}
}

struct patrash_answer_ptr *read_wan_ptr(word, ptr, fwan)
     char *word;
     off_t ptr;
     FILE *fwan;
{
	int i, c, pf, j;
	off_t  pintr;
	char   tmp_word[WDMAX], *tmp;
	struct patrash_answer_ptr *ptrr;

	if (fseek(fwan, (size_t)ptr, SEEK_SET)==-1) {
		perror("fwan");
		exit(1);
	}
	i = 0;
	tmp_word[0]='\0';
	while(fread(&tmp_word[i], sizeof(char), 1, fwan)==1) {
		if (tmp_word[i]=='\0') break;
		i++;
	}
	if (strcmp(word, tmp_word)==0) {
		if ((ptrr=calloc((size_t)1, sizeof(*ptrr)))==NULL)
		    merror("ptrr");
		if(fread(&pf, sizeof(int), 1, fwan)!=1) {
			perror("fread ptrr->pf");
			exit(1);
		}
		ptrr->pf  = pf;
		if ((ptrr->ptr=calloc((size_t)pf, sizeof(off_t)))==NULL) 
		    merror("ptrr->ptr");
		for(j=0; j<pf; j++) {
			if(fread(&pintr, sizeof(off_t), 1, fwan)!=1) {
				perror("fread ptrr->ptrr");
				exit(1);
			}
			ptrr->ptr[j] = pintr;
		}
		return ptrr;
	} else {
		return NULL;
	}
}

struct patrash_answer_int *tell_patrash_int (word, pa, fwan)
     char *word;
     struct patrash_array *pa;
     FILE *fwan;
{
	int i, j, k, x, pos, l, num;
	struct patrash_answer_int *intr;
	
	j = strlen(word);
	pos = 0;
	l = 1;
	intr=NULL;
	for (i=0; i<j; i++) {
		x = word[i];
		for (k=0; k<8; k++) {
			if (pos == pa[l].pos) {
				if (x & (1<<(7-k))) {
					l = pa[l].one;
				} else {
					l = pa[l].zero;
				}
			}
			pos++;
		}
	}
	if (pa[l].ptr!=(off_t)-1) {
		intr = read_wan_int(word, pa[l].ptr, fwan);
	}
	return intr;
}

int tell_patrash_int2 (word, pa, fwan)
     char *word;
     struct patrash_array *pa;
     FILE *fwan;
{
	int i, j, k, x, pos, l, num;
	
	j = strlen(word);
	pos = 0;
	l = 1;
	num=NULL;
	for (i=0; i<j; i++) {
		x = word[i];
		for (k=0; k<8; k++) {
			if (pos == pa[l].pos) {
				if (x & (1<<(7-k))) {
					l = pa[l].one;
				} else {
					l = pa[l].zero;
				}
			}
			pos++;
		}
	}
	if (pa[l].ptr!=(off_t)-1) {
		num = read_wan_int2(word, pa[l].ptr, fwan);
	}
	return num;
}

struct patrash_answer_double *tell_patrash_double (word, pa, fwan)
     char *word;
     struct patrash_array *pa;
     FILE *fwan;
{
	int i, j, k, x, pos, l;
	struct patrash_answer_double *dblr;
	
	j = strlen(word);
	pos = 0;
	l = 1;
	dblr=NULL;
	for (i=0; i<j; i++) {
		x = word[i];
		for (k=0; k<8; k++) {
			if (pos == pa[l].pos) {
				if (x & (1<<(7-k))) {
					l = pa[l].one;
				} else {
					l = pa[l].zero;
				}
			}
			pos++;
		}
	}
	if (pa[l].ptr!=(off_t)-1) {
		dblr = read_wan_double(word, pa[l].ptr, fwan);
	}
	return dblr;
}

struct patrash_answer_int_char *tell_patrash_int_char (word, pa, fwan)
     char *word;
     struct patrash_array *pa;
     FILE *fwan;
{
	int i, j, k, x, pos, l, num;
	struct patrash_answer_int_char *intchar;
	
	j = strlen(word);
	pos = 0;
	l = 1;
	intchar=NULL;
	for (i=0; i<j; i++) {
		x = word[i];
		for (k=0; k<8; k++) {
			if (pos == pa[l].pos) {
				if (x & (1<<(7-k))) {
					l = pa[l].one;
				} else {
					l = pa[l].zero;
				}
			}
			pos++;
		}
	}
	if (pa[l].ptr!=(off_t)-1) {
		intchar = read_wan_int_char(word, pa[l].ptr, fwan);
	}
	return intchar;
}

struct patrash_answer_char *tell_patrash_char (word, pa, fwan)
     char *word;
     struct patrash_array *pa;
     FILE *fwan;
{
	int i, j, k, x, pos, l, num;
	struct patrash_answer_char *pchar;
	
	j = strlen(word);
	pos = 0;
	l = 1;
	pchar=NULL;
	for (i=0; i<j; i++) {
		x = word[i];
		for (k=0; k<8; k++) {
			if (pos == pa[l].pos) {
				if (x & (1<<(7-k))) {
					l = pa[l].one;
				} else {
					l = pa[l].zero;
				}
			}
			pos++;
		}
	}
	if (pa[l].ptr!=(off_t)-1) {
		pchar = read_wan_char(word, pa[l].ptr, fwan);
	}
	return pchar;
}

struct patrash_answer_ptr *tell_patrash_ptr (word, pa, fwan)
     char *word;
     struct patrash_array *pa;
     FILE *fwan;
{
	int i, j, k, x, pos, l, num;
	struct patrash_answer_ptr *ptrr;
	
	j = strlen(word);
	pos = 0;
	l = 1;
	ptrr=NULL;
	for (i=0; i<j; i++) {
		x = word[i];
		for (k=0; k<8; k++) {
			if (pos == pa[l].pos) {
				if (x & (1<<(7-k))) {
					l = pa[l].one;
				} else {
					l = pa[l].zero;
				}
			}
			pos++;
		}
	}
	if (pa[l].ptr!=(off_t)-1) {
		ptrr = read_wan_ptr(word, pa[l].ptr, fwan);
	}
	return ptrr;
}
