/*
 * patrash_int_char.c
 *
 * Copyright (c) 1998-1999,2000,2001 Hajime Mochizuki <motizuki@jaist.ac.jp>
 *   Natural Language Processing Laboratory,
 *   Japan Advanced Institute of Science and Technology.
 *
 *
 * Use of this software is granted only for RESEARCH PURPOSES. 
 * Redistribution is granted as long as all copyright notices are retained.
 * Redistribution with modification is allowed provided that you make your 
 * modified version obviously distinguishable from the original one.  
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR 
 * IMPLIED WARRANTIES ARE DISCLAIMED.
 *
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include "patrash.h"

extern int moto_cell_num; /* debug λ */
extern int   debug;
extern struct moto_cell *node_moto_cell; /* debugΰ٤ */

static char *pname;
char *wfn;
int  mode;

static help ()
{

	fprintf (stderr, "patrash ver.0.001\n");
	fprintf (stderr, "Usage: %s\n", pname);
	fprintf (stderr, "\t[-WF] filename for output (test.*)\n");
	fprintf (stderr, "\t[-NS] use no sorted file  (sorted file)\n");
	fprintf (stderr, "\t[-D]  debug mode          (no_debug_mode)\n");
	fprintf (stderr, "\t[-h]  help\n");
	fprintf (stderr, " < chainfile\n");
	exit(1);
}

void optchk (argc, argv)
    int   argc;
    char *argv[];
{
	pname = argv[0];
	debug = 0;
	wfn   = "test";
	mode  = 0;
	argc--, argv++;
	
	while (argc>0 && *argv[0]=='-') {
		if (!strcmp(argv[0], "-h")) {
			help();
		} else if (!strcmp(argv[0], "-WF")) {
			argc--, argv++;
			wfn = argv[0];
		} else if (!strcmp(argv[0], "-NS")) {
			mode = 1;
		} else if (!strcmp(argv[0], "-D")) {
			debug = 1;
		} else {
			fprintf (stderr, "Invalid arg: %s\n", argv[0]);
			help();
		}
		argc--, argv++;
	}
}

int main (argc, argv)
    int   argc;
    char *argv[];
{
	char word[200], prewd[200], buf[BUFSIZ], wfnwan[200], wfnidx[200], dammy[20];
	int  idct, i, j, k;
	char *str=NULL;
	char str1[BUFSIZ], *tmp;
	int  num, prenum=0;
	off_t  *ids, id;
	FILE *wfwan, *wfidx;
	extern FILE* bopen_patrash_wan();
	extern FILE* bopen_patrash_idx();

	optchk (argc, argv);

	sprintf (wfnwan, "%s.wan", wfn);
	wfwan = bopen_patrash_wan(wfnwan);

	sprintf (wfnidx, "%s.idx", wfn);
	wfidx = bopen_patrash_idx(wfnidx);

	prewd[0]='\0';
	idct=0;
	while ((fgets(buf, BUFSIZ, stdin))!=NULL) {
		sscanf (buf, "%s %d %s\n", word, &num, str1);
		if ((strcmp(prewd, word))!=0 && prewd[0]!='\0') {
			bitter (prewd, mode);
			write_wan_type_int_char(prewd, prenum, str, wfwan);
			free(str); str=NULL;
			idct=0;
		}
		if (str==NULL) {
			str = strdup(str1);
		} else {
			if ((tmp=
			     realloc(str, sizeof(str)+ (sizeof(char)*strlen(str1))))
			    ==NULL) {
				perror("realloc");
				exit(1);
			}
			str = tmp;
			sprintf (str, "%s\n%s", str, str1);
		}
		prenum = num;
		strcpy (prewd, word);
		idct++;
	}
	bitter (prewd);
	write_wan_type_int_char(prewd, prenum, str, wfwan);
	free(str);
	if (debug==1) {
		check (node_moto_cell);
		printf ("total number of moto_cells = %d\n", moto_cell_num);
	}

	collect_moto_cell_last ();
	
	if (debug==1) {
		check (node_moto_cell);
		printf ("moto_cell_num = %d\n", moto_cell_num);
	}
	output_patrash_array(wfidx);
	printf ("total number of moto_cells = %d\n", moto_cell_num);
	fclose(wfwan);
	fclose(wfidx);
}
